=== debian/changelog ===
tubus (1.2-3+deb12u3) unstable; urgency=low

  * Install the package to '/opt' directory.

 -- Novemus Band <nineletters@mail.ru>  Thu, 1 Aug 2024 23:32:00 +0300

tubus (1.2-2+deb12u3) unstable; urgency=low

  * Building with default boost library.

 -- Novemus Band <nineletters@mail.ru>  Fri, 31 May 2024 23:32:00 +0300

tubus (1.2-1+deb12u3) unstable; urgency=low

  * Increased connection stability.

 -- Novemus Band <nineletters@mail.ru>  Tue, 26 Mar 2024 21:50:00 +0300

libtubus (1.1-1+deb12u3) unstable; urgency=low

  * Initial debian package.

 -- Novemus Band <nineletters@mail.ru>  Sat, 09 Dec 2023 13:57:40 +0300
