=== debian/control ===
Source: tubus
Section: devel
Priority: optional
Maintainer: Novemus Band <nineletters@mail.ru>
Build-Depends: cmake, debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: https://github.com/novemus/tubus
Rules-Requires-Root: no

Package: libtubus
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Runtime of the 'tubus' library
 This library implements a self obfuscated streaming transport
 protocol based on UDP.

Package: libtubus-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libboost-dev (>= 1.74) | libboost1.81-dev,
         libtubus (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files of the 'tubus' library
 This library provides a C++ implementation of a self obfuscated streaming
 transport protocol based on UDP.
